Subject: Re: [RFC] [PATCH] udp: optimize lookup of UDP sockets to by including destination address in the hash key

From: Eric Dumazet <[email-masked]>
Date: Thu, 05 Nov 2009 17:36:50 +0100

Octavian Purdila a écrit :

> IIRC, we first saw this issue in VoIP tests with up to 16000 sockets bound on a 
> certain port and IP addresses (each IP address is assigned to a particular 
> interface). We need this setup in order to emulate lots of VoIP users each 
> with a different IP address and possible a different L2 encapsulation.

Interesting case indeed, is it SIP 5060 port or RTP ports ?
(I want to know how many messages per second you want to receive)

An rbtree with 16000 elements has 15 levels, its a lot, but OK
for small trafic.

> 
> Now, as a general note I should say that our usecases can seem absurd if you 
> take them out of the network testing field :) but my _personal_ opinion is that 
> a better integration between our code base and upstream code may benefit both 
> upstream and us:
> 
> - for us it gives the ability to stay close to upstream and get all of the new 
> shiny features without painful upgrades
> 
> - for upstream, even if most systems don't run into these scalability issues 
> now, I see that some people are moving in that direction (see the recent PPP 
> problems); also, stressing Linux in that regard can only make the code better 
> - as long as the approach taken is clean and sound
> 
> - we (or our customers) use a plethora of networking devices for testing so 
> exposing Linux early to those devices can only help catching issues earlier
> 
> In short: expect more absurd patches from us :) 

I might cook something too :)